Package com.smartgwt.client.widgets.cube

# Class Facet

java.lang.Object
com.smartgwt.client.core.JsObject
com.smartgwt.client.core.DataClass
com.smartgwt.client.core.RefDataClass
com.smartgwt.client.widgets.cube.Facet

All Implemented Interfaces:
  `HasHandlers`

public class Facet extends RefDataClass
Facet definition object made use of by the `CubeGrid` and `FacetChart` classes.

- ## Field Summary

  ### Fields inherited from class com.smartgwt.client.core.RefDataClass

  `id`

  ### Fields inherited from class com.smartgwt.client.core.DataClass

  `factoryCreated, factoryProperties`

  ### Fields inherited from class com.smartgwt.client.core.JsObject

  `jsObj`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Facet()`
  `Facet(JavaScriptObject jsObj)`
  `Facet(String id)`
  `Facet(String id, String title)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Alignment`
  `getAlign()`
  Default alignment for facet label title, and cells for this facet.
  `String`
  `getBorderAfter()`
  CSS line style to apply as a border after this facet, eg "1px dashed blue"
  `String`
  `getBorderBefore()`
  CSS line style to apply as a border before this facet, eg "1px dashed blue"
  `Boolean`
  `getCanBeLegendFacet()`
  `false` if the facet cannot be the `legend facet`.
  `Boolean`
  `getCanCollapse()`
  For tree facets, whether expand/collapse controls should be shown.
  `Boolean`
  `getCanMinimize()`
  If facet minimizing is enabled, whether this facet should show controls to minimize the next facet.
  `Alignment`
  `getCellAlign()`
  Default alignment of cells (in the body) for this facet.
  `Boolean`
  `getCollapsed()`
  For tree facets, default collapse state for parent nodes.
  `Integer`
  `getHeight()`
  Integer number of pixels.
  `Object`
  `getId()`
  id of this facet.
  `Integer`
  `getIdAsInt()`
  id of this facet.
  `String`
  `getIdAsString()`
  id of this facet.
  `Boolean`
  `getIndentVTree()`
  Controls indenting for a `hierarchical` column facet if set non-null, overrriding the value of `CubeGrid.indentVTreeFacets`.
  `Boolean`
  `getInlinedValues()`
  When applied to a Chart, does the chart's data contain multiple values per record for this facet.
  `Boolean`
  `getIsTree()`
  Marks this facet as a hierarchical facet.
  `Integer`
  `getLabelHeight()`
  Integer number of pixels.
  `Boolean`
  `getMinimized()`
  Default `minimize state` for parent nodes.
  `static Facet`
  `getOrCreateRef(JavaScriptObject jsObj)`
  `String`
  `getProportionalTitle()`
  For `FacetCharts` only, this property specifies the value axis label when a FacetChart is in `proportional rendering mode` and has this facet as its `legend facet`.
  `String`
  `getRollupValue()`
  facetValueId of the rollup facetValue for this facet.
  `SelectionBoundary`
  `getSelectionBoundary()`
  Selection boundary determining what facets / facetValues can be selected together by drag selection / shift+click selection.
  `Boolean`
  `getSeparateFolders()`
  Should folders in the facet tree be sorted separately from leaves or should the facet values retain their data order regardless of whether a value is a leaf or folder in the tree?
  `Boolean`
  `getShowParentsLast()`
  Indicates internal hierarchy should be displayed in reverse of normal tree order (so that parents follow children).
  `Boolean`
  `getSortFoldersBeforeLeaves()`
  If `separateFolders` is true, should folders be displayed above or below leaves? When set to `true` folders will appear above leaves unless the data order has been reversed by setting `showParentsLast` to `true`.
  `String`
  `getSummaryTitle()`
  Title for facet summary.
  `String`
  `getSummaryValue()`
  Value for facet summary.
  `Boolean`
  `getSynchColumnLayout()`
  If true, treat all values in this facet as a facetValueGroup - causes synched header reorder and resize.
  `String`
  `getTitle()`
  User-visible title of this facet.
  `Alignment`
  `getTitleAlign()`
  Alignment of facet label title.
  `FacetValue[]`
  `getValues()`
  Array of facetValue definitions.
  `int`
  `getWidth()`
  Integer number of pixels.
  `Facet`
  `setAlign(Alignment align)`
  Default alignment for facet label title, and cells for this facet.
  `Facet`
  `setBorderAfter(String borderAfter)`
  CSS line style to apply as a border after this facet, eg "1px dashed blue"
  `Facet`
  `setBorderBefore(String borderBefore)`
  CSS line style to apply as a border before this facet, eg "1px dashed blue"
  `Facet`
  `setCanBeLegendFacet(Boolean canBeLegendFacet)`
  `false` if the facet cannot be the `legend facet`.
  `Facet`
  `setCanCollapse(Boolean canCollapse)`
  For tree facets, whether expand/collapse controls should be shown.
  `Facet`
  `setCanMinimize(Boolean canMinimize)`
  If facet minimizing is enabled, whether this facet should show controls to minimize the next facet.
  `Facet`
  `setCellAlign(Alignment cellAlign)`
  Default alignment of cells (in the body) for this facet.
  `Facet`
  `setCollapsed(Boolean collapsed)`
  For tree facets, default collapse state for parent nodes.
  `Facet`
  `setHeight(Integer height)`
  Integer number of pixels.
  `void`
  `setId(Integer id)`
  id of this facet.
  `void`
  `setId(String id)`
  id of this facet.
  `Facet`
  `setIndentVTree(Boolean indentVTree)`
  Controls indenting for a `hierarchical` column facet if set non-null, overrriding the value of `CubeGrid.indentVTreeFacets`.
  `Facet`
  `setInlinedValues(Boolean inlinedValues)`
  When applied to a Chart, does the chart's data contain multiple values per record for this facet.
  `Facet`
  `setIsTree(Boolean isTree)`
  Marks this facet as a hierarchical facet.
  `Facet`
  `setLabelHeight(Integer labelHeight)`
  Integer number of pixels.
  `Facet`
  `setMinimized(Boolean minimized)`
  Default `minimize state` for parent nodes.
  `Facet`
  `setProportionalTitle(String proportionalTitle)`
  For `FacetCharts` only, this property specifies the value axis label when a FacetChart is in `proportional rendering mode` and has this facet as its `legend facet`.
  `Facet`
  `setRollupValue(String rollupValue)`
  facetValueId of the rollup facetValue for this facet.
  `Facet`
  `setSelectionBoundary(SelectionBoundary selectionBoundary)`
  Selection boundary determining what facets / facetValues can be selected together by drag selection / shift+click selection.
  `Facet`
  `setSeparateFolders(Boolean separateFolders)`
  Should folders in the facet tree be sorted separately from leaves or should the facet values retain their data order regardless of whether a value is a leaf or folder in the tree?
  `Facet`
  `setShowParentsLast(Boolean showParentsLast)`
  Indicates internal hierarchy should be displayed in reverse of normal tree order (so that parents follow children).
  `Facet`
  `setSortFoldersBeforeLeaves(Boolean sortFoldersBeforeLeaves)`
  If `separateFolders` is true, should folders be displayed above or below leaves? When set to `true` folders will appear above leaves unless the data order has been reversed by setting `showParentsLast` to `true`.
  `Facet`
  `setSummaryTitle(String summaryTitle)`
  Title for facet summary.
  `Facet`
  `setSummaryValue(String summaryValue)`
  Value for facet summary.
  `Facet`
  `setSynchColumnLayout(Boolean synchColumnLayout)`
  If true, treat all values in this facet as a facetValueGroup - causes synched header reorder and resize.
  `Facet`
  `setTitle(String title)`
  User-visible title of this facet.
  `Facet`
  `setTitleAlign(Alignment titleAlign)`
  Alignment of facet label title.
  `Facet`
  `setValues(FacetValue... values)`
  Array of facetValue definitions.
  `Facet`
  `setWidth(int width)`
  Integer number of pixels.

  ### Methods inherited from class com.smartgwt.client.core.RefDataClass

  `getRef, getRef, internalSetID`

  ### Methods inherited from class com.smartgwt.client.core.DataClass

  `applyFactoryProperties, doAddHandler, fireEvent, getAttribute, getAttributeAsBoolean, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsDoubleArray, getAttributeAsElement, getAttributeAsFloat, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsLong, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getAttributes, getHandlerCount, isFactoryCreated, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttributeAsJavaObject, setFactoryCreated`

  ### Methods inherited from class com.smartgwt.client.core.JsObject

  `equals, getJsObj, hashCode, isCreated, setJavaScriptObject, setJsObj`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### Facet

    public Facet()

  - ### Facet

    public Facet(JavaScriptObject jsObj)

  - ### Facet

    public Facet(String id)

  - ### Facet

    public Facet(String id, String title)

- ## Method Details

  - ### getOrCreateRef

    public static Facet getOrCreateRef(JavaScriptObject jsObj)

  - ### setAlign

    public Facet setAlign(Alignment align)
    Default alignment for facet label title, and cells for this facet. Can be overridden at the facetValue level, or by setting titleAlign or cellAlign on the facet.

    Note: This property is specific to `CubeGrids` (see, for example, `CubeGrid.facetValueAlign`).

    Parameters:
      `align` - New align value. Default value is null
    Returns:
      `Facet` instance, for chaining setter calls
    See Also:
      - `setTitleAlign(com.smartgwt.client.types.Alignment)`
      - `setCellAlign(com.smartgwt.client.types.Alignment)`

  - ### getAlign

    public Alignment getAlign()
    Default alignment for facet label title, and cells for this facet. Can be overridden at the facetValue level, or by setting titleAlign or cellAlign on the facet.

    Note: This property is specific to `CubeGrids` (see, for example, `CubeGrid.facetValueAlign`).

    Returns:
      Current align value. Default value is null
    See Also:
      - `getTitleAlign()`
      - `getCellAlign()`

  - ### setBorderAfter

    public Facet setBorderAfter(String borderAfter)
    CSS line style to apply as a border after this facet, eg "1px dashed blue"

    Note: This property is specific to `CubeGrids`.

    Parameters:
      `borderAfter` - New borderAfter value. Default value is null
    Returns:
      `Facet` instance, for chaining setter calls

  - ### getBorderAfter

    public String getBorderAfter()
    CSS line style to apply as a border after this facet, eg "1px dashed blue"

    Note: This property is specific to `CubeGrids`.

    Returns:
      Current borderAfter value. Default value is null

  - ### setBorderBefore

    public Facet setBorderBefore(String borderBefore)
    CSS line style to apply as a border before this facet, eg "1px dashed blue"

    Note: This property is specific to `CubeGrids`.

    Parameters:
      `borderBefore` - New borderBefore value. Default value is null
    Returns:
      `Facet` instance, for chaining setter calls

  - ### getBorderBefore

    public String getBorderBefore()
    CSS line style to apply as a border before this facet, eg "1px dashed blue"

    Note: This property is specific to `CubeGrids`.

    Returns:
      Current borderBefore value. Default value is null

  - ### setCanBeLegendFacet

    public Facet setCanBeLegendFacet(Boolean canBeLegendFacet)
    `false` if the facet cannot be the `legend facet`.

    Note: This property is specific to `FacetCharts`.

    Note : This is an advanced setting

    Parameters:
      `canBeLegendFacet` - New canBeLegendFacet value. Default value is null
    Returns:
      `Facet` instance, for chaining setter calls

  - ### getCanBeLegendFacet

    public Boolean getCanBeLegendFacet()
    `false` if the facet cannot be the `legend facet`.

    Note: This property is specific to `FacetCharts`.

    Returns:
      Current canBeLegendFacet value. Default value is null

  - ### setCanCollapse

    public Facet setCanCollapse(Boolean canCollapse)
    For tree facets, whether expand/collapse controls should be shown.

    Note: This property is specific to `CubeGrids` (see, for example, `CubeGrid.canCollapseFacets`).

    Parameters:
      `canCollapse` - New canCollapse value. Default value is facet.isTree
    Returns:
      `Facet` instance, for chaining setter calls

  - ### getCanCollapse

    public Boolean getCanCollapse()
    For tree facets, whether expand/collapse controls should be shown.

    Note: This property is specific to `CubeGrids` (see, for example, `CubeGrid.canCollapseFacets`).

    Returns:
      Current canCollapse value. Default value is facet.isTree

  - ### setCanMinimize

    public Facet setCanMinimize(Boolean canMinimize)
    If facet minimizing is enabled, whether this facet should show controls to minimize the next facet. Generally a tree facet should not also allow minimizing the next facet - the interaction of the two types of collapsing can be confusing.

    Note: This property is specific to `CubeGrids`. See `CubeGrid.canMinimizeFacets`.

    Parameters:
      `canMinimize` - New canMinimize value. Default value is cubeGrid.canMinimizeFacets
    Returns:
      `Facet` instance, for chaining setter calls

  - ### getCanMinimize

    public Boolean getCanMinimize()
    If facet minimizing is enabled, whether this facet should show controls to minimize the next facet. Generally a tree facet should not also allow minimizing the next facet - the interaction of the two types of collapsing can be confusing.

    Note: This property is specific to `CubeGrids`. See `CubeGrid.canMinimizeFacets`.

    Returns:
      Current canMinimize value. Default value is cubeGrid.canMinimizeFacets

  - ### setCellAlign

    public Facet setCellAlign(Alignment cellAlign)
    Default alignment of cells (in the body) for this facet.

    Note: This property is specific to `CubeGrids`.

    Parameters:
      `cellAlign` - New cellAlign value. Default value is cubeGrid.cellAlign
    Returns:
      `Facet` instance, for chaining setter calls
    See Also:
      - `CubeGrid.setCellAlign(com.smartgwt.client.types.Alignment)`

  - ### getCellAlign

    public Alignment getCellAlign()
    Default alignment of cells (in the body) for this facet.

    Note: This property is specific to `CubeGrids`.

    Returns:
      Current cellAlign value. Default value is cubeGrid.cellAlign
    See Also:
      - `CubeGrid.getCellAlign()`

  - ### setCollapsed

    public Facet setCollapsed(Boolean collapsed)
    For tree facets, default collapse state for parent nodes.

    Note: This property is specific to `CubeGrids`.

    Parameters:
      `collapsed` - New collapsed value. Default value is false
    Returns:
      `Facet` instance, for chaining setter calls

  - ### getCollapsed

    public Boolean getCollapsed()
    For tree facets, default collapse state for parent nodes.

    Note: This property is specific to `CubeGrids`.

    Returns:
      Current collapsed value. Default value is false

  - ### setHeight

    public Facet setHeight(Integer height)
    Integer number of pixels. For column facets, specifies the height of header. Has no effect on row facets.

    If this property conflicts with a `labelHeight`, the greater of the two properties will be used for determining the height of the affected row.

    Note: This property is specific to `CubeGrids`.

    Parameters:
      `height` - New height value. Default value is null
    Returns:
      `Facet` instance, for chaining setter calls

  - ### getHeight

    public Integer getHeight()
    Integer number of pixels. For column facets, specifies the height of header. Has no effect on row facets.

    If this property conflicts with a `labelHeight`, the greater of the two properties will be used for determining the height of the affected row.

    Note: This property is specific to `CubeGrids`.

    Returns:
      Current height value. Default value is null

  - ### setIndentVTree

    public Facet setIndentVTree(Boolean indentVTree)
    Controls indenting for a `hierarchical` column facet if set non-null, overrriding the value of `CubeGrid.indentVTreeFacets`.
    Parameters:
      `indentVTree` - New indentVTree value. Default value is null
    Returns:
      `Facet` instance, for chaining setter calls
    See Also:
      - `CubeGrid.setVTreeFacetIndentDirection(com.smartgwt.client.types.FacetIndentDirection)`

  - ### getIndentVTree

    public Boolean getIndentVTree()
    Controls indenting for a `hierarchical` column facet if set non-null, overrriding the value of `CubeGrid.indentVTreeFacets`.
    Returns:
      Current indentVTree value. Default value is null
    See Also:
      - `CubeGrid.getVTreeFacetIndentDirection()`

  - ### setInlinedValues

    public Facet setInlinedValues(Boolean inlinedValues)
    When applied to a Chart, does the chart's data contain multiple values per record for this facet. See Chart.data for a full overview of `inlinedValues` behavior.
    Parameters:
      `inlinedValues` - New inlinedValues value. Default value is null
    Returns:
      `Facet` instance, for chaining setter calls

  - ### getInlinedValues

    public Boolean getInlinedValues()
    When applied to a Chart, does the chart's data contain multiple values per record for this facet. See Chart.data for a full overview of `inlinedValues` behavior.
    Returns:
      Current inlinedValues value. Default value is null

  - ### setIsTree

    public Facet setIsTree(Boolean isTree)
    Marks this facet as a hierarchical facet.

    If set, `facet.value` will be linked as for a `modelType:"parent"` Tree, using `facetValue.id` and `facetValue.parentId`. Expand/collapse controls will be shown allowing navigation of the facet's values.

    The CubeGrid's `load on demand` system automatically avoids fetching data for facetValues that are not currently visible due to the expand/collapse state of a tree facet.

    Initial open/close state can be controlled via `facet.collapsed` and `FacetValue.collapsed`.

    Note: This property is specific to `CubeGrids`.

    Parameters:
      `isTree` - New isTree value. Default value is false
    Returns:
      `Facet` instance, for chaining setter calls
    See Also:
      - `setShowParentsLast(java.lang.Boolean)`
      - `setSeparateFolders(java.lang.Boolean)`

  - ### getIsTree

    public Boolean getIsTree()
    Marks this facet as a hierarchical facet.

    If set, `facet.value` will be linked as for a `modelType:"parent"` Tree, using `facetValue.id` and `facetValue.parentId`. Expand/collapse controls will be shown allowing navigation of the facet's values.

    The CubeGrid's `load on demand` system automatically avoids fetching data for facetValues that are not currently visible due to the expand/collapse state of a tree facet.

    Initial open/close state can be controlled via `facet.collapsed` and `FacetValue.collapsed`.

    Note: This property is specific to `CubeGrids`.

    Returns:
      Current isTree value. Default value is false
    See Also:
      - `getShowParentsLast()`
      - `getSeparateFolders()`

  - ### setLabelHeight

    public Facet setLabelHeight(Integer labelHeight)
    Integer number of pixels. For column facets other than the innermost, specifies the height of the header. For row facets, specifies the height of the row containing that row facet's label (which is the same row containing the innermost column facet if one or more column facets are present).

    If this property conflicts with a `height`, the greater of the two properties will be used for determining the height of the affected row.

    Note: This property is specific to `CubeGrids`.

    Parameters:
      `labelHeight` - New labelHeight value. Default value is null
    Returns:
      `Facet` instance, for chaining setter calls

  - ### getLabelHeight

    public Integer getLabelHeight()
    Integer number of pixels. For column facets other than the innermost, specifies the height of the header. For row facets, specifies the height of the row containing that row facet's label (which is the same row containing the innermost column facet if one or more column facets are present).

    If this property conflicts with a `height`, the greater of the two properties will be used for determining the height of the affected row.

    Note: This property is specific to `CubeGrids`.

    Returns:
      Current labelHeight value. Default value is null

  - ### setMinimized

    public Facet setMinimized(Boolean minimized)
    Default `minimize state` for parent nodes.

    Note: This property is specific to `CubeGrids`.

    Parameters:
      `minimized` - New minimized value. Default value is false
    Returns:
      `Facet` instance, for chaining setter calls

  - ### getMinimized

    public Boolean getMinimized()
    Default `minimize state` for parent nodes.

    Note: This property is specific to `CubeGrids`.

    Returns:
      Current minimized value. Default value is false

  - ### setProportionalTitle

    public Facet setProportionalTitle(String proportionalTitle)
    For `FacetCharts` only, this property specifies the value axis label when a FacetChart is in `proportional rendering mode` and has this facet as its `legend facet`. If the `proportionalTitle` is not specified then `FacetChart.proportionalAxisLabel` is used as the default title.
    Parameters:
      `proportionalTitle` - New proportionalTitle value. Default value is null
    Returns:
      `Facet` instance, for chaining setter calls

  - ### getProportionalTitle

    public String getProportionalTitle()
    For `FacetCharts` only, this property specifies the value axis label when a FacetChart is in `proportional rendering mode` and has this facet as its `legend facet`. If the `proportionalTitle` is not specified then `FacetChart.proportionalAxisLabel` is used as the default title.
    Returns:
      Current proportionalTitle value. Default value is null

  - ### setRollupValue

    public Facet setRollupValue(String rollupValue)
    facetValueId of the rollup facetValue for this facet.

    Note: This property is specific to `CubeGrids`. See `CubeGrid.rollupValue`.

    Parameters:
      `rollupValue` - New rollupValue value. Default value is cubeGrid.rollupValue
    Returns:
      `Facet` instance, for chaining setter calls

  - ### getRollupValue

    public String getRollupValue()
    facetValueId of the rollup facetValue for this facet.

    Note: This property is specific to `CubeGrids`. See `CubeGrid.rollupValue`.

    Returns:
      Current rollupValue value. Default value is cubeGrid.rollupValue

  - ### setSelectionBoundary

    public Facet setSelectionBoundary(SelectionBoundary selectionBoundary)
    Selection boundary determining what facets / facetValues can be selected together by drag selection / shift+click selection.

    Note: This property is specific to `CubeGrids`.

    Parameters:
      `selectionBoundary` - New selectionBoundary value. Default value is null
    Returns:
      `Facet` instance, for chaining setter calls

  - ### getSelectionBoundary

    public SelectionBoundary getSelectionBoundary()
    Selection boundary determining what facets / facetValues can be selected together by drag selection / shift+click selection.

    Note: This property is specific to `CubeGrids`.

    Returns:
      Current selectionBoundary value. Default value is null

  - ### setSeparateFolders

    public Facet setSeparateFolders(Boolean separateFolders)
    Should folders in the facet tree be sorted separately from leaves or should the facet values retain their data order regardless of whether a value is a leaf or folder in the tree?
    Parameters:
      `separateFolders` - New separateFolders value. Default value is false
    Returns:
      `Facet` instance, for chaining setter calls
    See Also:
      - `setShowParentsLast(java.lang.Boolean)`
      - `setSortFoldersBeforeLeaves(java.lang.Boolean)`

  - ### getSeparateFolders

    public Boolean getSeparateFolders()
    Should folders in the facet tree be sorted separately from leaves or should the facet values retain their data order regardless of whether a value is a leaf or folder in the tree?
    Returns:
      Current separateFolders value. Default value is false
    See Also:
      - `getShowParentsLast()`
      - `getSortFoldersBeforeLeaves()`

  - ### setShowParentsLast

    public Facet setShowParentsLast(Boolean showParentsLast)
    Indicates internal hierarchy should be displayed in reverse of normal tree order (so that parents follow children).

    Note: This property is specific to `CubeGrids`.

    Parameters:
      `showParentsLast` - New showParentsLast value. Default value is false
    Returns:
      `Facet` instance, for chaining setter calls

  - ### getShowParentsLast

    public Boolean getShowParentsLast()
    Indicates internal hierarchy should be displayed in reverse of normal tree order (so that parents follow children).

    Note: This property is specific to `CubeGrids`.

    Returns:
      Current showParentsLast value. Default value is false

  - ### setSortFoldersBeforeLeaves

    public Facet setSortFoldersBeforeLeaves(Boolean sortFoldersBeforeLeaves)
    If `separateFolders` is true, should folders be displayed above or below leaves? When set to `true` folders will appear above leaves unless the data order has been reversed by setting `showParentsLast` to `true`.
    Parameters:
      `sortFoldersBeforeLeaves` - New sortFoldersBeforeLeaves value. Default value is true
    Returns:
      `Facet` instance, for chaining setter calls

  - ### getSortFoldersBeforeLeaves

    public Boolean getSortFoldersBeforeLeaves()
    If `separateFolders` is true, should folders be displayed above or below leaves? When set to `true` folders will appear above leaves unless the data order has been reversed by setting `showParentsLast` to `true`.
    Returns:
      Current sortFoldersBeforeLeaves value. Default value is true

  - ### setSummaryTitle

    public Facet setSummaryTitle(String summaryTitle)
    Title for facet summary.

    Note: This property is specific to `CubeGrids`.

    Parameters:
      `summaryTitle` - New summaryTitle value. Default value is cubeGrid.summaryTitle
    Returns:
      `Facet` instance, for chaining setter calls

  - ### getSummaryTitle

    public String getSummaryTitle()
    Title for facet summary.

    Note: This property is specific to `CubeGrids`.

    Returns:
      Current summaryTitle value. Default value is cubeGrid.summaryTitle

  - ### setSummaryValue

    public Facet setSummaryValue(String summaryValue)
    Value for facet summary.

    Note: This property is specific to `CubeGrids`.

    Parameters:
      `summaryValue` - New summaryValue value. Default value is cubeGrid.summaryValue
    Returns:
      `Facet` instance, for chaining setter calls

  - ### getSummaryValue

    public String getSummaryValue()
    Value for facet summary.

    Note: This property is specific to `CubeGrids`.

    Returns:
      Current summaryValue value. Default value is cubeGrid.summaryValue

  - ### setSynchColumnLayout

    public Facet setSynchColumnLayout(Boolean synchColumnLayout)
    If true, treat all values in this facet as a facetValueGroup - causes synched header reorder and resize.

    Note: This property is specific to `CubeGrids` and is only supported when all of a facet's values are used.

    Parameters:
      `synchColumnLayout` - New synchColumnLayout value. Default value is true
    Returns:
      `Facet` instance, for chaining setter calls

  - ### getSynchColumnLayout

    public Boolean getSynchColumnLayout()
    If true, treat all values in this facet as a facetValueGroup - causes synched header reorder and resize.

    Note: This property is specific to `CubeGrids` and is only supported when all of a facet's values are used.

    Returns:
      Current synchColumnLayout value. Default value is true

  - ### setTitle

    public Facet setTitle(String title)
    User-visible title of this facet. Shown on the facet label in the CubeGrid.
    Parameters:
      `title` - New title value. Default value is null
    Returns:
      `Facet` instance, for chaining setter calls

  - ### getTitle

    public String getTitle()
    User-visible title of this facet. Shown on the facet label in the CubeGrid.
    Returns:
      Current title value. Default value is null

  - ### setTitleAlign

    public Facet setTitleAlign(Alignment titleAlign)
    Alignment of facet label title.

    Note: This property is specific to `CubeGrids`.

    Parameters:
      `titleAlign` - New titleAlign value. Default value is cubeGrid.facetTitleAlign
    Returns:
      `Facet` instance, for chaining setter calls
    See Also:
      - `CubeGrid.setFacetTitleAlign(com.smartgwt.client.types.Alignment)`

  - ### getTitleAlign

    public Alignment getTitleAlign()
    Alignment of facet label title.

    Note: This property is specific to `CubeGrids`.

    Returns:
      Current titleAlign value. Default value is cubeGrid.facetTitleAlign
    See Also:
      - `CubeGrid.getFacetTitleAlign()`

  - ### setValues

    public Facet setValues(FacetValue... values)
    Array of facetValue definitions.
    Parameters:
      `values` - New values value. Default value is null
    Returns:
      `Facet` instance, for chaining setter calls
    See Also:
      - `FacetValue`

  - ### getValues

    public FacetValue[] getValues()
    Array of facetValue definitions.
    Returns:
      Current values value. Default value is null
    See Also:
      - `FacetValue`

  - ### setWidth

    public Facet setWidth(int width)
    Integer number of pixels. For row facets, width of headers.

    Note: This property is specific to `CubeGrids`.

    Parameters:
      `width` - New width value. Default value is cubeGrid.defaultFacetWidth
    Returns:
      `Facet` instance, for chaining setter calls
    See Also:
      - `CubeGrid.setDefaultFacetWidth(int)`

  - ### getWidth

    public int getWidth()
    Integer number of pixels. For row facets, width of headers.

    Note: This property is specific to `CubeGrids`.

    Returns:
      Current width value. Default value is cubeGrid.defaultFacetWidth
    See Also:
      - `CubeGrid.getDefaultFacetWidth()`

  - ### setId

    public void setId(Integer id)
    id of this facet. Any string or number.
    Parameters:
      `id` - id Default value is null

  - ### setId

    public void setId(String id)
    id of this facet. Any string or number.
    Parameters:
      `id` - id Default value is null

  - ### getId

    public Object getId()
    id of this facet. Any string or number.
    Parameters:
      `id` - id Default value is null

  - ### getIdAsString

    public String getIdAsString()
    id of this facet. Any string or number.
    Parameters:
      `id` - id Default value is null

  - ### getIdAsInt

    public Integer getIdAsInt()
    id of this facet. Any string or number.
    Parameters:
      `id` - id Default value is null